require 't2h_building_structure_tool/tst1_mod_profile_gen.rb'
require 't2h_building_structure_tool/tst1_mod_chamfer.rb'

##modified in 2013 02 19.
module TAK2HATA::T2H_BuildingStrcutureTool
module TST1_mod_create_geometry
	include TST1_mod_profile_gen
	include TST1_mod_chamfer
=begin
	def create_geometry( pts , pgeom = nil , sidevec = nil)
		start_operation("Create Geometry#{@beams_props["bclass"]}",true)
		#@beams_props["bclass"] = bclass
		#cgeom = drawStructure( pts , beams_spec , beams_just , beams_vjust , beams_axis , beams_top , beams_rot , beams_mirz , wall_width , beams_height , sidevec )
		cgeom = drawStructure2( pts , sidevec )
		Sketchup.active_model.commit_operation
		if pgeom != nil and ( @beams_props["bclass"] == "RC_WALL" or @beams_props["bclass"] == "MWALL" )
			start_operation("Combine with Structure",true)
			chamfer_form_MS( cgeom , cgeom.bounds.center , pgeom , pgeom.bounds.center )
			Sketchup.active_model.commit_operation
		end
		pgeom = nil

		if @beams_props["bclass"] == "RC_WALL" or @beams_props["bclass"] == "MWALL"
			return cgeom
		else
			return nil
		end
	end
=end
	def create_geometry2( pts , pgeom = nil , sidevec = nil)
		#@beams_props["bclass"]
		start_operation("Create Geometry#{@beams_props["bclass"]}")
		cgeom = drawStructure2( pts , sidevec )
		Sketchup.active_model.commit_operation
		if pgeom != nil and ( @beams_props["bclass"] == "RC_WALL" or @beams_props["bclass"] == "MWALL" )
			start_operation("",true)
				chamfer_form_MS( cgeom , cgeom.bounds.center , pgeom , pgeom.bounds.center )
			Sketchup.active_model.commit_operation
		end
		pgeom = nil
		#Sketchup.active_model.commit_operation
		if @beams_props["bclass"] == "RC_WALL" or @beams_props["bclass"] == "MWALL"
			return cgeom
		else
			return nil
		end
	end

	def drawStructure2( pts , sidevec = nil , tgr = nil , topfc = nil , btmfc = nil , stfc = nil , enfc = nil , changeheight = false )
		model=Sketchup.active_model
		model.layers.add "Structure-#{@beams_props["bclass"]}"
		if @beams_props["bclass"] == "MWALL"
			grp = drawMwall( pts )
			return grp
		end
		grpname = "#{@beams_props["tag"]}|#{@beams_props["bprofile"]}"
		if ["true","Yes"].include?(@beams_props["as_component"].to_s)
			ndf = model.definitions.add(grpname)
			ents= get_entities(ndf)
			cpoint=ents.add_cpoint([0,0,0])
			grp=model.active_entities.add_instance(ndf,Geom::Transformation.new)
		else
			grp=model.active_entities.add_group
			grp.name = grpname
			ents=get_entities(grp)
		end
		fl = 0.0 + @beams_props["beams_top"]
		rot = 0.0 + @beams_props["beams_rot"]
		shapePts = []
		shapetype = ""

		gw = 0.0
		gh = 0.0
		bprofile = @beams_props["bprofile"]
		if bprofile[/^\[SHAPE\](.*)/]
			shapename = $1.to_s
			shapetype = "SHAPE"
		elsif bprofile[/^B*H-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#H-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = getLengthByUnits( $4 )
			r1 = 0.0
			if bprofile[/^B*H-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $5 )
			end
			shapetype = "H"
		elsif bprofile[/^FB-*(\d+\.*\d*)[xX](\d+\.*\d*)/]
		#Cut Tee -STEEL
			gh = getLengthByUnits( $1 )
			gw = getLengthByUnits( $2 )
			shapetype = "FB"
		elsif bprofile[/^C*T-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#CT-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = getLengthByUnits( $4 )
			r1 = 0.0
			if bprofile[/^C*T-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $5 )
			end
			shapetype = "T"
		elsif bprofile[/^SHS-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#Rectang shape-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			r1 = 0.0
			if bprofile[/^SHS-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $4 )
			end
			shapetype = "SHS"

		elsif bprofile[/^CHS-*(\d+\.*\d*)[xX](\d+\.*\d*)/]
		#Circleshape-STEEL
			gh  = getLengthByUnits( $1 )
			gw = gh
			r = gh / 2.0
			gt1 = getLengthByUnits( $2 )
			shapetype = "CHS"
		elsif bprofile[/^L-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#L-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = gt1
			r1 = 0.0
			r2 = 0.0
			if bprofile[/^L-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $4 )
				r2 = getLengthByUnits( $5 )
			end
			shapetype = "L"
		#add_Lshape_face( gfrp , gw , gh , gt1 ,r1 , r2)
		elsif bprofile[/^C-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#C-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = getLengthByUnits( $4 )

			shapetype = "C"
		elsif bprofile[/^\[-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#[-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = getLengthByUnits( $4 )
			r1 = 0.0
			r2 = 0.0
			if bprofile[/^\[-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $5 )
				r2 = getLengthByUnits( $6 )
			end
			shapetype = "CC"
		elsif bprofile[/^RC-*(\d+\.*\d*)[xX](\d+\.*\d*)/] or bprofile[/^(\d+\.*\d*)[xX](\d+\.*\d*)/]
			gh  = getLengthByUnits( $2 )
			gw  = getLengthByUnits( $1 )
			shapePts.push [ 0, -gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , -gh/2]
			shapePts.push [ 0, -gw/2 , -gh/2]
			shapetype = "RECT"
		elsif bprofile[/^RCW-*(\d+\.*\d*)/] or bprofile[/^W-*(\d+\.*\d*)/]
			gh = @beams_props["beams_height"]
			gw = 0.0
			gw = getLengthByUnits( $1 ) if $1
			gw = @beams_props["wall_width"] if gw == 0.0
			shapePts.push [ 0, -gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , -gh/2]
			shapePts.push [ 0, -gw/2 , -gh/2]
			shapetype = "RECT"
		elsif bprofile[/^RCF-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
			#UI.messagebox "test"
			gh  = getLengthByUnits( $2 )
			gw  = getLengthByUnits( $1 )
			pts[1] = [ pts[0].x , pts[0].y , pts[0].z - getLengthByUnits( $3 ) ]
			shapePts.push [ 0, -gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , -gh/2]
			shapePts.push [ 0, -gw/2 , -gh/2]
		else
			return
		end

		ozvec = vec3d( 0,0,1 )
		#oyvec = vec3d( 0,1,0 )
		
		vec1to2 = pts[0].vector_to( pts[1] )
		dist = pts[0].distance(pts[1])
		xvec = vec1to2.normalize!
		#xvecはパスの方向のベクトル
		
		is_column = false
		if sidevec != nil and not sidevec.parallel?( xvec )
			#sidevecが指定されていて、sidevecとxvec（パス）が平行ではない場合
			zvec = xvec.cross( szvec ).reverse
			yvec = szvec.cross( xvec ).reverse
		else
			#sidevecが指定されていないか、sidevecとxvec（パス）が平行な場合
			if xvec.parallel?( ozvec ) or changeheight
				#xvec（パス）がZ軸と平行な場合（柱系）
				yvec =  vec3d( 1,0,0 )
				zvec = yvec.cross( xvec ).normalize.reverse
				is_column = true
				dist = @beams_props["beams_height"] if @beams_props["beams_height"] > 0
				#p beams_height
			else
				#p "not para zvec"
				yvec = ozvec.cross( xvec ).normalize
				#zvec = ozvec
				zvec = xvec.cross( yvec ).normalize
				#yvec.cross( xvec ).normalize
			end
		end

		trot = Geom::Transformation.rotation pt3d(0,0,0) , vec3d( 1,0,0 ) , 0
		if rot == 90.degrees
			gw , gh = gh ,gw
		end	

		if @beams_props["beams_just"] == "Left"
			tvec = Geom::Vector3d.new 0,-gw/2,0
		elsif @beams_props["beams_just"] == "Right"
			tvec = Geom::Vector3d.new 0,gw/2,0
		elsif @beams_props["beams_just"] == "Center"
			tvec = Geom::Vector3d.new 0,0,0
		end
		if @beams_props["beams_vjust"] == "Top"
			tvvec = Geom::Vector3d.new 0,0,-gh/2
		elsif @beams_props["beams_vjust"] == "Bottom"
			tvvec = Geom::Vector3d.new 0,0,gh/2
		elsif @beams_props["beams_vjust"] == "Middle"
			tvvec = Geom::Vector3d.new 0,0,0
		end
		if tgr == nil
			if ["true","Yes"].include?(@beams_props["beams_axis"].to_s)
				cline=ents.add_cline([0,0,0],[ dist , 0, 0 ] )
				cline.stipple="-.-"
				tgr = Geom::Transformation.translation tvec
				ents.transform_entities(tgr,cline)
			end
			
			tgr = Geom::Transformation.axes pts[0], xvec, yvec, zvec
			if fl != 0.0
				tvvec2 = Geom::Vector3d.new 0,0,fl
				tgr = Geom::Transformation.translation( tvvec2 ) * tgr
			end
		end
		grp.transform! tgr
		
		
		##shorino junban wo saikentousuru
		if rot == 90.degrees
			gw , gh = gh ,gw
		end	
			if shapetype == "SHAPE"
				fc = add_shapecomp_face( ents , shapename , gw , gh , @beams_props["subfolder"])
			elsif shapetype == "H"
				fc = add_Hshape_face( ents , gw , gh , gt1 , gt2 , r1  )
			elsif shapetype == "T"
				fc = add_Tshape_face( ents , gw , gh , gt1 , gt2 , r1  )
			elsif shapetype == "FB"
				fc = add_FBshape_face( ents , gw , gh )
			elsif shapetype == "SHS"
				fc = add_SHshape_face( ents , gw , gh , gt1 , r1 )
			elsif shapetype == "CHS"
				fc = add_CHshape_face( ents , gw , gh , gt1 , r )
			elsif shapetype == "L"
				fc = add_Lshape_face( ents , gw , gh , gt1 , gt2 ,r1 , r2 )
			elsif shapetype == "C"
				fc = add_Cshape_face( ents , gw , gh , gt1 ,gt2 )
			elsif shapetype == "CC"
				fc = add_CCshape_face( ents , gw , gh , gt1 , gt2, r1 , r2 )
			else
				fc = ents.add_face( shapePts )
			end
		if rot == 90.degrees
			gw , gh = gh ,gw
		end	
		
		if @beams_props["fmat"] != ""
			fmat = add_new_material( @beams_props["fmat"] )
			fc.material = fmat
		end
		if @beams_props["bmat"] != ""
			bmat = add_new_material( @beams_props["bmat"] )
			fc.back_material = bmat
		end
		if @beams_props["secmat"] != ""
			smmat = add_new_material( @beams_props["secmat"] )
			grp.material = smmat
		end
		if rot != 0
			trot = Geom::Transformation.rotation pt3d(0,0,0) , vec3d( 1,0,0 ) , rot
			ents.transform_entities(trot,fc)
		end
		#if is_column == false #柱系の場合は位置(just-vjust）を無視していたが、今回はあえて無視しない
			tvec = tvec + tvvec# + vec3d( 0, 0 , beams_top )
			t = Geom::Transformation.translation tvec
			ents.transform_entities(t,fc)
		#end
		if ["true","Yes"].include?(@beams_props["beams_mirz"].to_s)
			t = Geom::Transformation.scaling [0,0,0], 1 , -1 , 1
			ents.transform_entities(t,fc)
		end
		fc.reverse!
		fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_END")
		ptpts = pts.collect{|ptpt| ptpt.transform( tgr.inverse ) }
		#p "#{dist}"
		if pts.size == 2
			fc.pushpull dist,true
			fc.reverse!	
			fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_START")
			startfcvec = fc.normal
		else
			#if is_column == false
			#コラムの場合にパスが曲線のものを無視していたが、今回は無視せずに作る
				rail = ents.add_curve( ptpts )
				fc.reverse!
				fc.followme rail
				fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_START") if fc.valid?
				startfcvec = fc.normal if fc.valid?
			#else
			#	return
			#end
		end
		#startfcvec = ptpts[1].vector_to( ptpts[0] )
		endfcvec = startfcvec.reverse if startfcvec != nil

		ents.find_all{|e| is_kind(e,"Face") }.each{|fc|
			softedges = fc.edges.find_all{|fced| fced.soft? == true }
			if endfcvec != nil and fc.normal.samedirection?( endfcvec ) and softedges == []
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_END")
			elsif startfcvec != nil and fc.normal.samedirection?( startfcvec ) and softedges == []
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_START")
			elsif @beams_props["bclass"] == "RC_WALL" #shapetype == "RECT" #bprofile[/RC.*/]
				if fc.normal.samedirection? vec3d( 0,0,1 )
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_TOP")
				elsif fc.normal.samedirection? vec3d( 0,0,-1 )
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_BOTTOM")
				elsif fc.normal.samedirection? vec3d( 0,-1,0 )
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_LEFT")
				elsif fc.normal.samedirection? vec3d( 0,1,0 )
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_RIGHT")
				end
			else
				fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_SIDE")
			end
		}

		ents.find_all{|e| is_kind(e,"Edge") and e.smooth? == false }.each{|ed|
			ed.set_attribute( "BEAMS_FACES", "LOCATION" , "ED_OUTLINE")
		}
		##extend with faces
		newtr = Geom::Transformation.new
			if changeheight == true and ( @beams_props["bclass"] == "RC_COLUMN" or @beams_props["bclass"] == "STEEL_COLUMN" )
				p "not fit to face"
			else
				if enfc != nil
					plane2 = enfc[0].plane
					fcs = get_endface( grp )
					if fcs != nil
					fcs.each{|fc|
						extend_do( grp , fc , newtr , plane2 )
					}
					end
				end
				if stfc != nil
					plane2 = stfc[0].plane
					fcs = get_startface( grp )
					if fcs != nil
					fcs.each{|fc|
						extend_do( grp , fc , newtr , plane2 )
					}
					end
				end
			end
			if changeheight == false
				if @beams_props["bclass"] == "RC_WALL"  or @beams_props["bclass"] == "RC_COLUMN" or @beams_props["bclass"] == "STEEL_COLUMN"
					if btmfc != nil
						plane2 = btmfc[0].plane
						fcs = get_bottomface( grp )
						if fcs != nil
						fcs.each{|fc|
							extend_do( grp , fc , newtr , plane2 )
						}
						end
					end
				end
				if @beams_props["bclass"] == "RC_WALL" or @beams_props["bclass"] == "RC_COLUMN" or @beams_props["bclass"] == "STEEL_COLUMN"
					if topfc != nil
						plane2 = topfc[0].plane
						fcs = get_topface( grp )
						if fcs != nil
						fcs.each{|fc|
							extend_do( grp , fc , newtr , plane2 )
						}
						end
					end
				end
			end
		##
		#grp.name = grpname
		grp.set_attribute( "BEAM_SPECS","CLASS",@beams_props["bclass"])
		grp.set_attribute( "BEAM_SPECS","HUGO",@beams_props["tag"])
		grp.set_attribute( "BEAM_SPECS","PROFILE",@beams_props["bprofile"])
		grp.set_attribute( "BEAM_SPECS","MATERIAL",@beams_props["solid_mat"])
		#grp.set_attribute "BEAM_SPECS","FL",fl
		grp.set_attribute( "BEAM_SPECS","ROTATE",rot)
		grp.set_attribute( "BEAM_SPECS","MIRRORZ",@beams_props["beams_mirz"])
		path_set_attribute( grp, pts)
		grp.set_attribute( "BEAM_SPECS","HJUST", @beams_props["beams_just"])
		grp.set_attribute( "BEAM_SPECS","VJUST", @beams_props["beams_vjust"])
		grp.set_attribute( "BEAM_SPECS","TOP", @beams_props["beams_top"])
		grp.set_attribute( "BEAM_SPECS","WIDTH", @beams_props["wall_width"])
		grp.set_attribute( "BEAM_SPECS","HEIGHT", @beams_props["beams_height"])
		grp.set_attribute( "BEAM_SPECS","SVEC", sidevec)
		
		set_ifc_attribute(grp)
		
		if ptpts.size > 2
			grp.set_attribute( "BEAM_SPECS","CURVE",true)
		else
			grp.set_attribute( "BEAM_SPECS","CURVE",false)
		end
		ipt = [ pts[0].distance( pts[1] )/2 , 0,0]
		#draw_hugo_text( grp , ipt , hugo , bprofile)
		
		ents.find_all{|de| is_kind(de,"Drawingelement") }.each{|e| e.layer = "Structure-#{@beams_props["bclass"]}" }
		if ["true","Yes"].include?(@beams_props["as_component"].to_s)
			cpoint.erase!
		end
		 #topfc = nil , btmfc = nil , stfc = nil , enfc
		#p "add label"
		#label_hugo_text(grp , hugo , ipt )
		return grp
	end

	def drawMwall( pts )#, beams_prof , beams_mirz ,subfolder = ".")
		#@beams_props["bprofile"] , @beams_props["beams_mirz"] , @beams_props["subfolder"]
		model = Sketchup.active_model
		if @beams_props["subfolder"] and @beams_props["subfolder"] != "" and @beams_props["subfolder"] != "."
			path = bst_file_join( bst_file_dirname( __FILE__ ), 'mwalls' , @beams_props["subfolder"] , bst_u8tosjis( @beams_props["bprofile"] ) )
		else
			path = bst_file_join( bst_file_dirname( __FILE__ ), 'mwalls' , bst_u8tosjis( @beams_props["bprofile"] ) )
		end

		return if FileTest.exist?(path) != true
		definitions = model.definitions
		model.commit_operation
		cdef = definitions.load( path )
		start_operation("",true)
		cdbb = cdef.bounds
		cup = 0
		#model.commit_operation
		#start_operation("EXTEND MWALL")
		get_entities(cdef).find_all{|e| e.get_attribute( "BEAM_SPECS","CLASS" ) != nil }.each{|cdent|
			cdent.set_attribute("BEAM_SPECS","COUNT",cup.to_s) if cdent.get_attribute("BEAM_SPECS","COUNT") == nil
			cup += 1
		}

		gw = 0.0
		gh = 0.0
		gh = cdbb.height
		gw = cdbb.depth
		
		tf = Geom::Transformation.new#( pt3d( 0,0,0 ) )
		#grp = model.active_entities.add_group
		chk_dc = false
		if cdef.attribute_dictionaries and cdef.attribute_dictionaries["dynamic_attributes"]
			if cdef.entities.find{|e| e.get_attribute( "BEAM_SPECS","CLASS" ) }
				mwall = model.active_entities.add_instance( cdef , tf )
				ents = get_entities(mwall)
				chk_dc = true
			else
				mwall = model.active_entities.add_group
				ents = get_entities(mwall)
				cins = ents.add_instance( cdef , tf )
			end
		else
			mwall = model.active_entities.add_group
			ents = get_entities(mwall)
			cins = ents.add_instance( cdef , tf )
			cins.explode
		end

		ozvec = vec3d( 0,0,1 )

		if ozvec.parallel?( vec3d( 0,0,1 ) )
			oyvec = vec3d( 0,1,0 )
		else
			oyvec = ozvec.cross( vec3d( 0,0,1 ) ).normalize
		end
		vec1to2 = pts[0].vector_to( pts[1] )
		dist = pts[0].distance(pts[1])
		xvec = vec1to2.normalize!
		col = false
		
		if xvec.parallel?( ozvec )
			yvec = oyvec
			zvec = xvec.cross( yvec ).normalize
			col = true
		else
			yvec = ozvec.cross( xvec ).normalize
			zvec = xvec.cross( yvec ).normalize
		end
		
		tvec = Geom::Vector3d.new 0,0,0
		trot = Geom::Transformation.rotation pt3d(0,0,0) , vec3d( 1,0,0 ) , 0

		tgr = Geom::Transformation.axes pts[0], xvec, yvec, zvec

		mwall.transform!( tgr )

		if ["true","Yes"].include?(@beams_props["beams_mirz"].to_s)
			t = Geom::Transformation.scaling( [0,0,0], 1 , -1 , 1)
			ents.transform_entities(t, ents.collect{|e| e } )
		else
		end
		dcchk = false
		ptpts = pts.collect{|ptpt| ptpt.transform( tgr.inverse ) }
		if pts.size == 2
			extcnt = 0
			ents.find_all{|e| is_kind(e,"ComponentInstance","Group") }.each{|ent|
				sfc = get_startface(ent)
				efc = get_startface(ent)
				if sfc and efc
					ent.make_unique
					ps1 = pt3d(0,0,0)
					tf1 = ent.transformation
					plane2 = [ pt3d( dist,0,0 ) , vec3d( -1,0,0) ]
					extend_form_do( ent , tf1 , ps1 , plane2 )
					#sctype = check_schematype(ent)
					#if sctype and sctype == ""
						set_ifc_attribute(ent)
					#end
				elsif is_kind(ent,"ComponentInstance" ) and ent.definition.attribute_dictionaries and ent.definition.attribute_dictionaries["dynamic_attributes"]
					gl=ent.definition.bounds.max.x
					nl=pts[0].distance(pts[1])
					ent.transform!(Geom::Transformation.scaling(nl/gl,1,1))
					path_set_attribute(ent,pts)
					if dcchk == true or defined?($dc_observers)
						dcchk = true
						$dc_observers.get_latest_class.redraw_with_undo( ent )
						model.commit_operation
						start_operation("",true)
					elsif dcchk == false
						UI.messagebox "Reuqire Dynamic_Components Extension when do this operation."
						dcchk = true
					end
					if ent.get_attribute( "BEAM_SPECS","CLASS","" ) == ""
						ent.set_attribute( "BEAM_SPECS","CLASS","DC_WALL" )
					end
					ent.set_attribute( "BEAM_SPECS","CURVE",false ) 
				end
				if ent.get_attribute( "BEAM_SPECS","HUGO", "") == ""
					ent.set_attribute( "BEAM_SPECS","HUGO", "MWALLS:#{extcnt}")
				end
				extcnt += 1
			}
		else
			#if col == false
			#	rail = ents.add_curve( ptpts )
			#	fc.reverse!
			#	fc.followme rail
			#else
			#	return
			#end
		end
		#model.commit_operation
		#start_operation("SET MWALL ATTRIBUTE",true)
		bstcount = ents.find_all{|e| e.get_attribute( "BEAM_SPECS","CLASS","" ) != "" }.size
		if bstcount == 1 and chk_dc == false
			exents = mwall.explode
			model.commit_operation
			start_operation("",true)
			retent = exents.find_all{|e| e.get_attribute( "BEAM_SPECS","CLASS","" ) != "" }[0]
			return retent
		else
			mwall.name = "MWALL-#{ bst_file_basename( @beams_props["bprofile"] , "*.skp" )}"
			mwall.set_attribute( "BEAM_SPECS","CLASS","MWALL")
			mwall.set_attribute( "BEAM_SPECS","HUGO", "")
			mwall.set_attribute( "BEAM_SPECS","PROFILE", @beams_props["bprofile"])
			path_set_attribute( mwall, pts)
			mwall.set_attribute( "BEAM_SPECS","MIRRORZ",@beams_props["beams_mirz"])
			if ptpts.size > 2
				mwall.set_attribute( "BEAM_SPECS","CURVE",true)
			else
				mwall.set_attribute( "BEAM_SPECS","CURVE",false)
			end
			ipt = [ pts[0].distance( pts[1] )/2 , 0,0]

			return mwall
		end
	end

	#def auto_create_from_lines2( beams_props , sellines , nvec = nil )
	def auto_create_from_lines2( sellines , nvec = nil )
		#@beams_props["bclass"] = bclass
		allpts = []
		
		start_operation("Draw Multi Building Structures")
		pts = []
		curveids = []
		ppts = []
		pgeom = nil
		##
		sellines.each{|e|
			pts = []
			#MWALLの場合はセグメントごとに書くのでエッジで集める
			if is_kind(e,"ConstructionLine")
				pts[0] = e.start
				pts[1] = e.end
			elsif is_kind(e,"Edge")
				if e.curve == nil or @beams_props["bclass"] == "MWALL"
					pts[0] = e.start.position
					pts[1] = e.end.position 
				elsif curveids.index( e.curve.entityID ) == nil
					pts = e.curve.vertices.collect{|vt| vt.position }
					curveids.push e.curve.entityID
				end
			end
			if pts != []
				pts.each{|ptpt|
					if allpts.find_all{|pt| pt == ptpt }.size == 0
						allpts.push ptpt
					end
				}
				#allpts.push pts[1] if allpts.find_all{|pt| pt == pts[1] }.size == 0
				if @beams_props["bclass"] == "STEEL_COLUMN" or @beams_props["bclass"] == "RC_COLUMN" or @beams_props["bclass"] == "RC_FOOTING"
				elsif @beams_props["bclass"]== "MWALL" or @beams_props["bclass"] == "RC_WALL"
					if pts.size > 2
						cgeom = drawStructure2( pts )
					else
						if ppts != []
							if ppts[0] == pts[1] or ppts[1] == pts[0] or ppts[0] == pts[0] or ppts[1] == pts[1]
								cgeom = create_geometry2( pts , pgeom )
							else
								cgeom = create_geometry2( pts )
							end
						else
							cgeom = create_geometry2( pts )
						end
						ppts = pts
						pgeom = cgeom
					end
				else
					cgeom = drawStructure2( pts )
				end
			end
		}
		#allpts.uniq!
		if @beams_props["bclass"] == "STEEL_COLUMN" or @beams_props["bclass"] == "RC_COLUMN"
			allpts.each{|apt|
				pts[0] = [ apt.x , apt.y , apt.z ]
				pts[1] = [ apt.x , apt.y , apt.z + @beams_props["beams_height"] ]
				cgeom = drawStructure2( pts)
			}
		elsif @beams_props["bclass"] == "RC_FOOTING"
			allpts.each{|apt|
				pts[0] = [ apt.x , apt.y , apt.z ]
				pts[1] = [ apt.x , apt.y , apt.z + 1000.mm ]
				cgeom = drawStructure2( pts)
			}
		end
		Sketchup.active_model.commit_operation
	end
	def createSlabFromFace( ofc , t = Geom::Transformation.new , from_pt = false)
		if from_pt == false
			start_operation( "click to slab" )
		end
			@thickness = getLengthByUnits( @beams_props["bprofile"].split("-")[1] )
			if @thickness == 0.0
				p "No Thickness"
				return
			end
			eds = ofc.edges
			model = Sketchup.active_model
			ents = model.active_entities

			elist = []
			#elist.push fc
			ofc.edges.each{|ed| elist.push ed } 

			fcgrp = ents.add_group( elist )
			#t = Geom::Transformation.translation( vec3d( 0,0, ( @beams_props["slab_toplevel"] - @beams_props["slab_hitlevel"] ) ) )
			fcgrp.transform! t
			get_entities(fcgrp).find_all{|e| is_kind(e,"Edge") }.each{|e2| e2.find_faces }

			get_entities(fcgrp).find_all{|e| is_kind(e,"Face")}.each{|e2|
				e2.material = add_new_material( @beams_props["fmat"] ) if @beams_props["fmat"] != ""
				e2.back_material = add_new_material( @beams_props["bmat"] ) if @beams_props["bmat"] != ""
			}
			get_entities(fcgrp).find_all{|e| is_kind(e,"Face")}.each{|e2|
				e2.pushpull @thickness
			}

			if ["true","Yes"].include?(@beams_props["as_component"].to_s)
				fcins = fcgrp.to_component
				fcins.definition.name = "#{@hugo}|#{@beams_props["bprofile"]}"
			else
				fcgrp.name = "#{@hugo}|#{@beams_props["bprofile"]}"
				fcins = fcgrp
			end
			fcins.set_attribute( "BEAM_SPECS","CLASS","SLAB")
			fcins.set_attribute( "BEAM_SPECS","HUGO",@beams_props["tag"])
			fcins.set_attribute( "BEAM_SPECS","PROFILE",@beams_props["bprofile"])
			fcins.set_attribute( "BEAM_SPECS","MATERIAL",@beams_props["solid_mat"])
			fcins.set_attribute( "BEAM_SPECS","FL",@beams_props["slab_toplevel"])
			set_ifc_attribute(fcins)
			
			killist = []
			eds.each{|ed| killist.push ed if ed.faces.size <= 1 }
			killist.push ofc
			ents.erase_entities killist
		Sketchup.active_model.commit_operation if from_pt == false
		return
	end
	#def intersect_plane( ents = Sketchup.active_model.active_entities , tr = transformation.new , planeZ , grp , intgrp )
	#	fcents = ents.find_all{|e| is_kind(e,"Face") }
	#	grp.entities.intersect_with( true , grp.trnasformation , intgrp  , inttr , false , fcents )
	#	ents.find_all{|e| is_kind(e) }.each{|ci|		}
	#end
	def create_slab_withPT( intpt , plane1 )
		start_operation( "click to slab")

		model = Sketchup.active_model
		ents = model.active_entities

		grp = ents.add_group
		rad = model.bounds.diagonal * 2.0
		cen = model.bounds.center.project_to_plane( plane1 )
		cen = intpt

		#cir = get_entities(grp).add_ngon( cen , [ 0.0 , 0.0 , 1.0 ] , @beams_props["slab_hitrange"] , 4 )
		cir = get_entities(grp).add_ngon( cen , [ 0.0 , 0.0 , 1.0 ] , rad , 4 )
		get_entities(grp).add_face cir
		intgrp = ents.add_group
		inttr = intgrp.transformation

		model.active_entities.intersect_with( true , Geom::Transformation.new , intgrp  , inttr , false , grp  )
		#intgrp.entities.add_face( intgrp.entities.find_all{|e| is_kind(e Sketchup::Edge } )
		get_entities(intgrp).find_all{|e| is_kind(e,"Edge") }.each{|e2| e2.find_faces }
		get_entities(grp).erase_entities get_entities(grp).find_all{|e| is_kind(e,"Face") }

		killist = []
		killist.push grp
		killist.push intgrp
		fcs = get_entities(intgrp).find_all{|e| is_kind(e,"Face") }
		if fcs.size > 0
			
			fc2 = fcs.find_all{|fc| fc.classify_point( intpt ) == 1 }
			if fc2.size > 0
				t = Geom::Transformation.translation( vec3d( 0,0, ( @beams_props["slab_toplevel"] - @beams_props["slab_hitlevel"] ) ) )
				createSlabFromFace( fc2[0] , t , true )
				ents.erase_entities killist
				Sketchup.active_model.commit_operation
				return true
			else
				#p "nothing"
				Sketchup.active_model.commit_operation
				Sketchup.undo
				return false
			end
		else
			Sketchup.active_model.commit_operation
			Sketchup.undo
			return false
		end
	end
	def label_hugo_text(grp , hugo , ipt )
		return nil if hugo == ""
		layers = Sketchup.active_model.layers
		layers.add "Structure-TAG-TEXT" if not layers["Structure-TAG-TEXT"]
		
		ents = get_entities(grp)
		#hgrp = ents.add_group
		
		defs = Sketchup.active_model.definitions
		#path = File.join( File.dirname( File.expand_path(__FILE__) ), "bst_tag1.skp" )
		path = bst_file_join( bst_file_dirname( __FILE__ ), "bst_tag1.skp" )
		#Sketchup.find_support_file "bst_tag1.skp","plugins/building_structure_tool"
		df = defs["bst_tag1"]
		df = defs.load path if not df
		p "bst_tag1 loaded"
		t = Geom::Transformation.translation( [0,0,0].vector_to( ipt ) )
		ci = ents.add_instance df , t
		ci.layer = "Structure-TAG-TEXT"
		ci.explode.each{|e|
			if is_kind(e,"Text")
				e.text = hugo
				#e.visible = false
			end
			e.layer = "Structure-TAG-TEXT"
		}
		
		#hgrp.layer = "Structure-TAG-TEXT"
		#hgrp.explode
	end
	def label_dimw(grp , width , ipt )
		return nil if width == 0.0
		ents = get_entities(grp)
		
		defs = Sketchup.active_model.definitions
		##path = File.join( File.dirname( File.expand_path(__FILE__) ), "bst_dimw1.skp" )
		path = bst_file_join( bst_file_dirname( __FILE__ ), "bst_dimw1.skp" )
		#Sketchup.find_support_file "bst_dimw1.skp","plugins/building_structure_tool"
		df = defs.load path
		t = Geom::Transformation.scaling( [0,0,0] , width / 100.mm )
		t = Geom::Transformation.translation( [0,0,0].vector_to( ipt ) ) * t
		ci = ents.add_instance df , t
		myset = []
		cents = ci.explode
		cents.each{|e|
			if is_kind(e,"Edge")
				myset.push e
			elsif is_kind(e,"Drawingelement")
				e.layer = "Structure_DimensionW"
			end
		}
		ents.erase_entities myset
	end
	def draw_hugo_text( grp , ipt , hugo , profile)
		return nil if hugo == ""
		layername = "Structure-TAG-TEXT"
		layers = Sketchup.active_model.layers
		layers.add layername if not layers[ layername ]
		
		ents = get_entities(grp)
		tstr = hugo + "\n" + profile
		txt = ents.add_text( tstr , ipt )
		txt.layer = layers[ layername ]

	end
	def add_new_material( mname = "" )
		mats = Sketchup.active_model.materials
		if mats[ mname ] == nil
			mat = mats.add mname
			mat.color = "white"
		else
			mat = mats[ mname ]
		end
		return mat
	end

end#module
end#module