require 'sketchup.rb'
require 't2h_building_structure_tool/tst1_mod_common_util.rb'
require 't2h_building_structure_tool/tst1_mod_bst_table_editor_dummy.rb'
module TAK2HATA::T2H_BuildingStrcutureTool
module TST1_class_table_editor
		include TST1_mod_common_util
		include TST1_mod_bst_table_editor_dummy

		def init_table_wdlg(chkdummy)
			$bst_tedit_wdlg.execute_script(%Q{selectListbox('#{$bst_parts_units}')})
			if @tst_langhash
				jcmd = ""
				@tst_langhash.each{|k,v|
					if v and v != ""
					jcmd = jcmd + %Q{translate_lang("#{k}","#{v}");}
					end
				}
				$bst_tedit_wdlg.execute_script(jcmd)
				jcmd = ""
				cnt=0
				["OTHER","STEEL_GIRDER","STEEL_BEAM","STEEL_COLUMN","RC_GIRDER","RC_BEAM","RC_COLUMN","RC_WALL","RC_FOOTING","SLAB"].each{|tabname|
					jcmd = jcmd + %Q{$('#tabs ul:first li:eq(#{cnt}) a').text("#{langconv(tabname)}");}
					cnt += 1
				}
				$bst_tedit_wdlg.execute_script(jcmd)
				rbcolnameslist = %Q{["} + ["TAG", "PROFILE", "GAP TOP LEVEL", "SOLID MATERIAL", "ROTATION", "FRONT MAT", "BACK MAT", "SECTION MAT"].map{|st| @tst_langhash[st] }.join(%Q{","})+ %Q{"]}
				$bst_tedit_wdlg.execute_script( %Q{var colnameslist=#{rbcolnameslist};})
			end
			if chkdummy == false
			pflisthash , pfpath = readProfiles()
			bstlist = ["OTHER","STEEL_GIRDER","STEEL_BEAM","STEEL_COLUMN","RC_GIRDER","RC_BEAM","RC_COLUMN","RC_WALL","RC_FOOTING","SLAB"]
			bstlist.each{|bl|
				stgdata = []
				pflisthash[bl].each{|pf|
					if pf and pf.strip.chomp != ""
						pfarr = pf.split("\t")
						if pfarr.size > 7
							stgdata.push %Q{{tag:"#{pfarr[0].gsub(/\"/,'\"')}",profile:"#{pfarr[1].gsub(/\"/,'\"')}",gap_level:"#{pfarr[2].gsub(/\"/,'\"')}",solidmat:"#{pfarr[3].gsub(/\"/,'\"')}",rotation:"#{pfarr[4].gsub(/\"/,'\"')}",fmat:"#{pfarr[5].gsub(/\"/,'\"')}",bmat:"#{pfarr[6].gsub(/\"/,'\"')}",secmat:"#{pfarr[7].gsub(/\"/,'\"')}"}}
						end
					end
				}
				if stgdata.size > 0
					$bst_tedit_wdlg.execute_script( %Q{var gname="#{bl}";var database = [#{stgdata.join(",")}];createGridFromArray(gname,database);} )
				end
			}
			$bst_tedit_wdlg.execute_script( %Q{set_tsv_path("#{pfpath}")})
			end
		end
		def show_table_editor()
			if $bst_tedit_wdlg
				$bst_tedit_wdlg.bring_to_front
				return
			end
			##stime = Time.now.to_f
			bst_folder_path = bst_file_dirname( __FILE__ )
			tblwdlg_path = bst_file_join(bst_folder_path,"bst_table_editor.html")
			pfpath = ""
			pfpath = get_pflist_path()
			prfkeys = { 
				:dialog_title => 'BST Table Editor>>' + pfpath, 
				:scrollable => true, 
				:preferences_key => 'tst_bst_table_editor', 
				:height => 445, 
				:width => 980, 
				:left => 150, 
				:top => 150, 
				:resizable => true, 
				:mac_only_use_nswindow => true
			}
			$bst_tedit_wdlg = UI::WebDialog.new( prfkeys )
			chkdummy = false
			if File.exists?(tblwdlg_path)
				$bst_tedit_wdlg.set_file( tblwdlg_path )
			else
				pflisthash , pfpath = readProfiles()
				chkdummy = true
				tbuff = bst_table_editor_dummy()
				tbuff = langconv_html(tbuff)
				if tbuff != nil
					bst_folder_path = bst_file_dirname( __FILE__ )
					tarr = tbuff.split(/[\n\r]+/)
					bstlist = ["OTHER","STEEL_GIRDER","STEEL_BEAM","STEEL_COLUMN","RC_GIRDER","RC_BEAM","RC_COLUMN","RC_WALL","RC_FOOTING","SLAB"]
					(tarr.size).times{|i|
						bstlist.each{|bl|
							if tarr[i].include?('//' + bl + '_DATA_STORE//')
								#$bst_parts_units is gotten in this time.
								stgdata = []
								pflisthash[bl].each{|pf|
									tmpdata = []
									if pf and pf.strip.chomp != ""
										pfarr = pf.split("\t")
										tmpdata.push( "tag:" + '"' + pfarr[0].gsub(/\"/,'\"') + '"' ) if pfarr[0]
										tmpdata.push( "profile:" + '"' + pfarr[1].gsub(/\"/,'\"') + '"' ) if pfarr[1]
										tmpdata.push( "gap_level:" + '"' + pfarr[2].gsub(/\"/,'\"') + '"') if pfarr[2]
										tmpdata.push( "solidmat:" + '"' + pfarr[3].gsub(/\"/,'\"') + '"') if pfarr[3]
										tmpdata.push( "rotation:" + '"' + pfarr[4].gsub(/\"/,'\"') + '"') if pfarr[4]
										tmpdata.push( "fmat:" + '"' + pfarr[5].gsub(/\"/,'\"') + '"') if pfarr[5]
										tmpdata.push( "bmat:" + '"' + pfarr[6].gsub(/\"/,'\"') + '"') if pfarr[6]
										tmpdata.push( "secmat:" + '"' + pfarr[7].gsub(/\"/,'\"') + '"') if pfarr[7]
										stgdata.push( "{" + tmpdata.join(",") + "}" )
									end
								}
								tarr[i] = "database = [\n" + stgdata.join(",\n") + "\n];"
								break
							end
						}
					}
					tbuff = tarr.join("\n")

					bst_folder_path.gsub!(/\\/,"/")
					tbuff.gsub!("//BST_FOLDER//",bst_folder_path)

					p "show webdialog by CODE"
					bst_folder_path.gsub!(/\\/,"/")
					tbuff.gsub!("//BST_FOLDER//",bst_folder_path)
					$bst_tedit_wdlg.set_html( tbuff )
				end
			end

			$bst_tedit_wdlg.add_action_callback("load_file"){|d,prm|
				res = change_defaultPFPath()
				if res != false
					$bst_tedit_wdlg.execute_script( %Q{set_tsv_path("")})
					$bst_tedit_wdlg.close
					$bst_tedit_wdlg = nil
					show_table_editor()
				end
			}
			$bst_tedit_wdlg.set_on_close{
				if $bst_tedit_wdlg.get_element_value("TSV_PATH") != ""
					res = UI.messagebox(langconv("Save TSV before closing Editor?"),MB_YESNO)
					if res == 6
						$bst_tedit_wdlg.execute_script(%Q{savingGrid();})
					end
				end
				$bst_tedit_wdlg = nil
			}
			$bst_tedit_wdlg.add_action_callback("buff_save"){|d,prm|
				saveGrid()
			}
			$bst_tedit_wdlg.add_action_callback("set_bstdia"){|d,prm|
				bstclass = $bst_tedit_wdlg.get_element_value("BSTCLASS")
				if $bst_tool_wdlg and bstclass
					jcmd = "changedBstClass('" + bstclass + "')"
					$bst_tool_wdlg.execute_script(jcmd)
				end
			}
			

			if RUBY_PLATFORM[/darwin/]
				$bst_tedit_wdlg.show_modal { init_table_wdlg(chkdummy) }
			else
				$bst_tedit_wdlg.show {
					init_table_wdlg(chkdummy) 
					##p "waste=#{Time.now.to_f - stime}"
				}
			end
		end
		def saveGrid()
			schema_units = "mm"
			if $bst_tedit_wdlg.get_element_value("SCHEMA_UNITS")
				schema_units = $bst_tedit_wdlg.get_element_value("SCHEMA_UNITS")
			end
			tbuff = $bst_tedit_wdlg.get_element_value("SENDTEXT")
			#bstclass = $bst_tedit_wdlg.get_element_value("BSTCLASS")
			#UI.messagebox( bstclass );
			if tbuff.strip != ""
				tccheck = $bst_tedit_wdlg.get_element_value("TSV_CSV")
				databuff = []
				aline = "#(0)TAG	(1)Profile	(2)GAP_LEVEL	(3)SOLID MATERIAL	(4)Rotate	(5)FrontColor	(6)BackColor	(7)SectionColor"
				bline = "#SETTINGS	JISTYPE	" + schema_units + ( "\t" * 5 )
				databuff.push aline
				databuff.push bline
				databuff.push tbuff.split("|||")  ##.map{|tb| tb.gsub("|||||||","\t") }
				databuff.flatten!
				if tccheck == "csv" or tccheck == "tsv"
					saveProfileList( databuff , tccheck )
				else
					saveProfileList( databuff )
				end
				if tccheck == "csv"
				else
					bstclass = $bst_tedit_wdlg.get_element_value("BSTCLASS")
					if $bst_tool_wdlg and bstclass
						jcmd = "changedBstClass('" + bstclass + "')"
						$bst_tool_wdlg.execute_script(jcmd)
					end
				end
				databuff = nil
				$bst_tedit_wdlg.execute_script("clear_sendbox()")
			end
		end
end#module
end#module
